#include <iostream>
#include "math.h"
#include <stdlib.h>
#include <stdio.h>

using namespace std;

void CSRkug(int n, double *entries, int *column_indices, int *row_offset)
{
int i,j,k,l;
row_offset[0]=0;

//Sonderbehandlung für 0-ten (Südpol)  ((n-1)*n+1)-ten (Nordpol) Eintrag
row_offset[1]=n;
for (i=0;i<n;++i)
	{
	column_indices[i] = i+1;	// Südpol (0-ter Knoten) hat jeweils Kanten zu Knoten 1 bis n+1. 
	entries[i] = 0;				// Liegen auf Längenkreis. 
	}
	//Die nächsten (n-1)*n Knoten haben jeweils 4 Kanten zu anderen Knoten. 
	//Vorsicht, linker und rechter Rand des Gitters müssen separat behandelt 
	//werden. 
j = 0;
for (i=1; i<(n-1)*n+1; ++i)
	{
	row_offset[i+1] = row_offset[i] + 4;
	if ((i-1)%n==0)	
		{//Falls i-1 durch n teilbar ist, ist man am linken Rand vom Gitter 
		j += 1;
		//Startet ein neuer Breitengrad

		column_indices[row_offset[i]] = (int) max(i-n,0); 
		entries[row_offset[i]] = 0;
		column_indices[row_offset[i]+1] = i+1;
		entries[row_offset[i]+1] = 0;
		column_indices[row_offset[i]+2] = i+n-1;
		entries[row_offset[i]+2] = 0;
		column_indices[row_offset[i]+3] = (int) min(i+n,(n-1)*n+1);
		entries[row_offset[i]+3] = 0;
		}
	else if (i%n==0)
		{//Falls i durch n teilbar ist, ist man am rechten Rand vom Gitter
		column_indices[row_offset[i]] = (int) max(i-n,0);
		entries[row_offset[i]] = 0;
		column_indices[row_offset[i]+1] = i-n+1;
		entries[row_offset[i]+1] = 0;
		column_indices[row_offset[i]+2] = i-1;
		entries[row_offset[i]+2] = 0;
		column_indices[row_offset[i]+3] = (int) min(i+n,(n-1)*n+1);
		entries[row_offset[i]+3] = 0;
		}
	else 
		{//sonst ist man im Inneren des Gitters
		column_indices[row_offset[i]] = (int) max(i-n,0);
		entries[row_offset[i]] = 0;
		column_indices[row_offset[i]+1] = i-1;
		entries[row_offset[i]+1] = 0;
		column_indices[row_offset[i]+2] = i+1;
		entries[row_offset[i]+2] = 0;
		column_indices[row_offset[i]+3] = (int) min(i+n,(n-1)*n+1);
		entries[row_offset[i]+3] = 0;
		}
	}
//Sonderbehandlung für ((n-1)*n+1)-ten (Nordpol) Eintrag
row_offset[(n-1)*n+2] = row_offset[(n-1)*n+1]+n;
for (i=0;i<n;++i)
	{
	column_indices[row_offset[(n-1)*n+1]+i] = (n-2)*n+1+i;  
	// Nordpol hat jeweils Kanten zu Knoten (n-1)*n+1 bis (n-2)*n. 
	entries[row_offset[(n-1)*n+1]+i] = 0;
	}

}

/*
int main(){

int n, i;
double *entries;
int *column_indices, *row_offset;

n=4;

entries =(double*) malloc((4*(n-1)*n+2*n)*sizeof(double));
column_indices = (int*)malloc((4*(n-1)*n+2*n)*sizeof(int));
row_offset = (int*)malloc(((n-1)*n+3)*sizeof(int));

CSRkug(n,entries,column_indices, row_offset);


cout <<"[";
for (i=0;i<4*(n-1)*n+2*n;i++)
cout <<column_indices[i]<<",";

cout <<"]"<<endl;
cout <<"[";
for (i=0;i<4*(n-1)*n+2*n;i++)
cout <<entries[i]<<",";
cout <<"]"<<endl;

cout <<"[";
for (i=0;i<(n-1)*n+3;i++)
cout <<row_offset[i]<<",";

cout <<"]"<<endl;

free(entries);
free(column_indices);
free(row_offset);

return 0;
}
*/


